#include "UniqueColorGenerator.h"

#include <assert.h>

#ifndef WIN32
UniqueColorGenerator *UniqueColorGenerator::m_instance=NULL;
#endif

UniqueColorGenerator::UniqueColorGenerator(void)
					:m_next_color_to_give(0)
{
	m_generated_colors.push_back(Color(0.0, 0.0, 1.0));
	m_generated_colors.push_back(Color(0.0, 1.0, 0.0));
	m_generated_colors.push_back(Color(0.0, 1.0, 1.0));
	m_generated_colors.push_back(Color(1.0, 0.0, 0.0));
	m_generated_colors.push_back(Color(1.0, 0.0, 1.0));
	m_generated_colors.push_back(Color(1.0, 1.0, 0.0));

	m_generated_colors.push_back(Color(0.0, 0.0, 0.5));
	m_generated_colors.push_back(Color(0.0, 0.5, 0.0));
	m_generated_colors.push_back(Color(0.0, 0.5, 0.5));
	m_generated_colors.push_back(Color(0.5, 0.0, 0.0));
	m_generated_colors.push_back(Color(0.5, 0.0, 0.5));
	m_generated_colors.push_back(Color(0.5, 0.5, 0.0));
}

Color UniqueColorGenerator::getUniqueColor(void)
{
	assert(m_generated_colors.size() > 0);

	assert(m_next_color_to_give < m_generated_colors.size());

	Color result = m_generated_colors[m_next_color_to_give];
	
	m_next_color_to_give++;

	if (m_next_color_to_give == m_generated_colors.size())
	{
		m_next_color_to_give = 0;
	}

	return result;
}
